=== debian/changelog ===
openvas-scanner (20.8.0-2) unstable; urgency=medium

  [ Sophie Brun ]
  * Add a patch to fix test failure (Closes: #976712)

  [ Raphael Hertzog ]
  * Update patch meta-data
  * Add some lintian overrides

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 21 Dec 2020 15:27:49 +0100

openvas-scanner (20.8.0-1) unstable; urgency=medium

  * Team upload.

  [ Sophie Brun ]
  * New upstream version 20.8.0
  * Update debian/copyright
  * Change required version of libgvm-dev: 20.8.0
  * Refresh patches
  * Add a comment about OPENVAS_RUN_DIR in debian/rules
  * Update debian/rules with correct run dir and feed lock path

  [ SZ Lin (林上智) ]
  * Update copyright information
  * I am no longer using this package, and thus remove my name from the
    uploaders field due to time constraints

 -- Raphaël Hertzog <raphael@offensive-security.com>  Thu, 03 Dec 2020 15:18:05 +0100
